/*
    CharityWorld: AllHappySupplyAgents.h
    Copyright (C) 2003  Macaulay Institute

    This file is part of CharityWorld, a simple agent-based model to
    demonstrate the effects of errors in floating point arithmetic on
    emergent outcomes.

    CharityWorld is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CharityWorld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/* 

CharityWorld

This file contains the declaration for four classes:
HappySupplyAgent, ExtAvgHappySupplyAgent,
MeanHappySupplyAgent, and ExtMeanHappySupplyAgent.
They only differ on the class they inherit from.
The implementation of the methods that they override 
is exactly the same for all the classes.
(A dodgy way of doing multiple inheritance )

*/

#import "AllSimpleSupplyAgents.h"

/*

HappySupplyAgent.h

The HappySupplyAgent inherits from the SimpleSupplyAgent. 
His criterion for deciding whom to offer to is different.

*/

@interface HappySupplyAgent: SimpleSupplyAgent {
}

-(BOOL)offeringCondition: (Agent *)nbr;

@end


/*

ExtAvgHappySupplyAgent.h

The ExtAvgHappySupplyAgent inherits from the ExtAvgSimpleSupplyAgent.
His criterion for deciding whom to offer to is different.

*/

@interface ExtAvgHappySupplyAgent: ExtAvgSimpleSupplyAgent {
}

-(BOOL)offeringCondition: (Agent *)nbr;

@end


/*

MeanHappySupplyAgent.h

The MeanHappySupplyAgent inherits from the MeanSimpleSupplyAgent.
His criterion for deciding whom to offer to is different.

*/

@interface MeanHappySupplyAgent: MeanSimpleSupplyAgent {
}

-(BOOL)offeringCondition: (Agent *)nbr;

@end


/*

ExtMeanHappySupplyAgent.h

The ExtMeanHappySupplyAgent inherits from the ExtMeanSimpleSupplyAgent.
His criterion for deciding whom to offer to is different.

*/

@interface ExtMeanHappySupplyAgent: ExtMeanSimpleSupplyAgent {
}

-(BOOL)offeringCondition: (Agent *)nbr;

@end
